;    File Version:  000.001                                           *
;    Author:        PSW.RU                                            *
;    Company:       Labs                                              *
;     IntOnChange .
;      /  
;    .    
;         -   .
	list      p=12F683           ; list directive to define processor
	#include <p12f683.inc>       ; processor specific variable definitions
	#include <PswMacro.inc>		;   PSW 
	errorlevel  -302              ; suppress message 302 from list file

;	__CONFIG   0x31C4 ;    
 __CONFIG _CP_OFF & _WDT_OFF & _MCLRE_OFF & _PWRTE_ON & _HS_OSC & _BOD_ON
; '__CONFIG' directive is used to embed configuration word within .asm file.

; STATUS bit definitions
#define		_C			STATUS,C
#define		_Z			STATUS,Z
;  ( ) .
;  20 .     RC  400   0,1 ,
;          .
#define		OutputPort	GPIO				;  / (  12 )
;       / .
#define		ICSPDat		0		;   -  IntOnChange  ,
;      -     ?
;#define	ICSPDatDebug		1	;  
;									;  
#define		MainIn		1		;    
#define		PWMOut		2		;   PWM
#define		Reset		3		;  .
#define		ClcOut		4		;  20  .
#define		ClcIn		5		;  20  .
;***** VARIABLE DEFINITIONS
Pg_0			res	0x20;    020  - 64  .
;   
w_temp			res	1	;EQU     0x20       ; variable used for context saving 
status_temp		res	1	;EQU     0x21       ; variable used for context saving
Counter		    res	1	;EQU     0x22		;   
CountDel		res	1	;EQU     0x23		;   
CountAvr		res	1	;EQU     0x23		;   
;      
GPIO_Buf	EQU	0x70	;  GPIO    
Flag_Reg	EQU	0x71	;      

;     -    Watcher
; AARGB0_			EQU		AARGB0		; 
;**********************************************************************
		ORG     0x000             ; processor reset vector
		goto    init              ; go to beginning of program

		ORG     0x004             ; interrupt vector location
;    IntOnChange,     ,
;    ,    -  .
;		movwf   w_temp            ; save off current W register contents
;		movf	STATUS,w          ; move status register into W register
;		movwf	status_temp       ; save off contents of STATUS register
;		btfss	INTCON,T0IF		  ; Timer0 ?
;		goto	NextInt1
	bcf STATUS,RP0;======= set file register bank to 0
		movff	OutputPort,GPIO_Buf	;   .
		bcf		INTCON,GPIF			;   .
		btfsc	GPIO_Buf,MainIn		;     
		goto	Trans2Hi			; 
		goto	Trans2Lo			;
;  200    .     6 ,
;    5 /(2^(6-2))=312,5 ,  200  
; 62.5  ,   60    /.
;        
; 16  -       .
Delay	;      12   
; Call / Return
	nop

 ifndef ICSPDatDebug	;   -  
	nop ;    
	nop ;    
 else
	bcf	OutputPort,ICSPDat	;   
 endif

	nop
	nop
	nop
	nop
	nop
	return
SendValue2PWM	macro	Literal8	; 8    
	NOLIST
; local DutyHigh,DutyLow
;	movlf	b'00001111',CCP1CON ;  2  =  5/4
;		clrf	CCPR1L			;  4  
DutyHigh = Literal8 >> 2	;     
DutyHigh = DutyHigh & b'00011111'	;   
DutyLow = Literal8 << 4	;
DutyLow = DutyLow & b'00110000' ;  
DutyLow = DutyLow | b'00001111' ;  
 if Literal8 > 0x41 
DutyHigh = b'00010000'	;  -
DutyLow  = b'00111111'
 endif
 if Literal8 < 0x0 
DutyHigh = b'00000000'	;  -
DutyLow  = b'00001111'
 endif

 ifndef ICSPDatDebug	;   -  
 else
	bsf	OutputPort,ICSPDat	;   
 endif


	movlf	DutyHigh,CCPR1L	;    
	movlf	DutyLow,CCP1CON	;    
;    16    -  12 
;     - 1966  , 52 .
;         .
;   ,      
; 5  624  
;  120   
; 4   1.25    240 .
; ,        ?
	call Delay ; Call + Return = 4 . 12-4=8  
	LIST
	endm
;   -  60  6  
;       . 
;
Trans2Hi	;      =100%

	#include <Trans2Hi.inc>	;     
; SendValue2PWM	0x1	; 
; SendValue2PWM	0x13; 
; SendValue2PWM	0x25; 
; SendValue2PWM	0x3F; 
; SendValue2PWM	0x47; .
;		bsf		OutputPort,PWMOut	;   
;	movff	OutputPort,GPIO_Buf	;     .
;	bcf		INTCON,GPIF			;   .
		retfie
Trans2Lo
	nop		;      
	#include <Trans2Lo.inc> ;     
; SendValue2PWM	0x3F
; SendValue2PWM	0x21
; SendValue2PWM	0x13
; SendValue2PWM	0xA
; SendValue2PWM	0x0
;		bcf		OutputPort,PWMOut	;   
;	movff	OutputPort,GPIO_Buf	;     .
;	bcf		INTCON,GPIF			;   .
		retfie
RetInt	;    
;		movf    status_temp,w     ; retrieve copy of STATUS register
;		movwf	STATUS            ; restore pre-isr STATUS register contents
;		swapf   w_temp,f
;		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt

init
	bcf STATUS,RP0;======= set file register bank to 0
		clrf	OutputPort		  ;    
		movlf	b'00000111',CMCON0;   
		clrf	ADCON0	  		  ;  
	bsf STATUS,RP0;======= set file register bank to 1 
		clrf	PIE1	;    
		clrf	ANSEL			;    -  .
		movlf	b'11111111',TRISIO	;   
		bcf		TRISIO,PWMOut		;  
		bcf		TRISIO,ICSPDat		; 
		movlf	b'00110111',WPU ;1=WPU   
		clrf	INTCON
		clrf	IOC				;     IntOnChange
		bsf		IOC,MainIn		;      
;		movlf	b'00000010',IOC ;1=Int On Change Enable -    
		bcf		OPTION_REG,NOT_GPPU	;   
		movlf	b'00001111',PR2 ;    = 16 
	bcf STATUS,RP0;======= set file register bank to 0
		clrf	CCPR1L			;   =0
		clrf	T2CON	  		  ;  2
		bsf		T2CON,TMR2ON	  ;   / .
		movlf	b'00001111',CCP1CON ;  PWM 
		bsf		INTCON,GPIE		;    GPIO
		bsf		INTCON,GIE		;    



Main	clrwdt	;     .
	bcf STATUS,RP0;======= set file register bank to 0
		nop		; 
	goto	Main
		END                      ; directive 'end of program'

